apt-get(8)

NAZWA
apt-get - narzędzie zarządzania pakietami APT -- interfejs linii poleceń

SKŁADNIA

apt-get [opcje] [polecenie] [pakiet ...]

OPIS
apt-get jest narzędziem do zarządzania pakietami działającym z linii poleceń i może być uważane za wewnętrzne narzędzie apt(8).

polecenie jest jednym z:

o   update

o   upgrade

o   dselect-upgrade [1]

o   dist-upgrade

o   install pakiet1 [pakiet2] [...]

o   remove pakiet1 [pakiet2] [...]

o   source pakiet1 [pakiet2] [...]

o   check

o   clean

o   autoclean

Jeżeli nie zostanie podana opcja -h lub --help, musi być użyte jedno z powyższych poleceń.

Uwaga: [1] Wyłącznie dla systemów Debian

update
    update jest używane do zsynchronizowania zawartości plików indeksu pakietów z ich źródłem. Lista dostępnych pakietów jest pobierana z lokalizacji określonych w pliku /etc/apt/sources.list. Na przykład, gdy używane jest archiwum Debiana, to polecenie pobiera i przegląda pliki Packages.gz, tak żeby udostępnić informacje o nowych i uaktualnionych pakietach. Polecenie update powinno być użyte zawsze przed upgrade lub dist-upgrade. Należy zauważyć, że licznik całkowitego postępu operacji jest błędny, ponieważ rozmiar plików Packages.gz nie jest wcześniej znany.

upgrade
    upgrade instaluje najnowsze wersje wszystkich aktualnie zainstalowanych w systemie pakietów, na podstawie źródeł wymienionych w pliku /etc/apt/sources.list. Zainstalowane pakiety, których nowsza wersja jest dostępna, są pobierane i uaktualniane; w żadnym wypadku podanie tej opcji nie spowoduje usunięcia zainstalowanego pakietu ani pobrania i zainstalowania nowego pakietu, wcześniej nie zainstalowanego. Pakiety, których nowa wersja wymaga zmiany statusu (np. zainstalowania bądź usunięcia) innego pakietu, nie będą uaktualnione. Aby apt-get wiedział, że są dostępne nowe wersje pakietów, należy wcześniej wykonać update.

dselect-upgrade
    dselect-upgrade jest używane w połączeniu z nakładką dselect (8), tradycyjnym narzędziem do zarządzania pakietami w systemie Debian GNU/Linux. dselect-upgrade śledzi zmiany pola Status dostępnych pakietów, wykonane programem dselect i podejmuje działania niezbędne do osiągnięcia określonego tam stanu (na przykład poprzez usunięcie starych pakietów i dodanie nowych). Polecenie to jest dostępne jedynie na systemach Debian.

dist-upgrade
    dist-upgrade wykonuje to samo, co upgrade, jednakże w inteligentny sposób wykrywa zmiany zależności międzypakietowych w nowych wersjach pakietów. apt-get ma wbudowany "sprytny" system rozwiązywania konfliktów i jeśli będzie to potrzebne, podejmie próbę zaktualizowania najważniejszych pakietów, kosztem tych mniej ważnych. Plik /etc/apt/sources.list zawiera listę adresów, z których będą pobierane żądane pakiety.

install
    po install musi występować nazwa jednego lub więcej pakietów przeznaczonych do zainstalowania. Każdy argument jest nazwą pakietu, a nie pełną nazwą pliku, w którym się znajduje (na przykład, w systemie Debian GNU/Linux tym argumentem byłoby ldso, a nie ldso_1.9.6-2.deb). Wszystkie pakiety, niezbędne do zainstalowania żądanego(-ych) pakietu(-ów), będą także pobrane i zainstalowane. Plik /etc/apt/sources.list zawiera listę adresów, z których będą pobierane żądane pakiety. Jeżeli przed nazwą pakietu pojawi się minus (bez spacji pomiędzy minusem a nazwą pakietu), to ten pakiet zostanie usunięty, o ile oczywiście jest zainstalowany. Ta ostatnia właściwość może być użyta do nadpisania decyzji, podjętych przez system rozwiązywania konfliktów programu apt-get.

    Jeżeli żaden pakiet nie pasuje do podanego wyrażenia, a wyrażenie to zawiera jeden z następujących znaków: '.', '?' lub '*', to zakłada się, że jest to wyrażenie regularne zgodne z POSIX-em i odnosi się ono do wszystkich nazw pakietów w bazie. Pakiety, których nazwy pasują do tego wyrażenia regularnego, są instalowane (bądź usuwane). Należy zwrócić uwagę na to, że dopasowywany jest podciąg, tak więc 'lo*' pasuje zarówno do wyrażenie znakiem '^'.

remove
    remove odpowiada poleceniu install z tą różnicą, że pakiety są usuwane, a nie instalowane. Jeżeli nazwa pakietu zostanie poprzedzona znakiem plusa (bez rozdzielającej spacji), wskazany pakiet zostanie zainstalowany.

source
    source powoduje, że apt-get pobiera pakiety ze źródłami. APT na podstawie listy dostępnych pakietów decyduje, który pakiet źródłowy ściągnąć. Następnie szuka najnowszej dostępnej wersji pakietu ze źródłami i pobiera ją do bieżącego katalogu. Pakiety ze źródłami są znajdowane inaczej niż pakiety binarne: przez linie z identyfikatorem deb-src lub rpm-src w pliku sources.list. Może to oznaczać, że pobrany pakiet źródłowy nie będzie odpowiadał pakietowi binarnemu, który jest lub mógłby być zainstalowany. Jeżeli podano opcję --compile, pakiet źródłowy zostanie skompilowany do pakietu binarnego .deb za pomocą programu dpkg-buildpackage, a na systemach opartych na RPM, do pakietu binarnego .rpm za pomocą rpm -ba. Podanie opcji --download-only spowoduje natomiast, że pakiet źródłowy nie zostanie rozpakowany.

    Uwaga. Pakiety źródłowe nie są traktowane tak samo, jak pakiety binarne. Istnieją one tylko w bieżącym katalogu i ich pobieranie jest podobne do pobierania innych paczek ze żródłami.

check
    check jest poleceniem diagnostycznym, które odświeża bufor pakietów i poszukuje pakietów uszkodzonych.

clean
    clean czyści lokalne repozytorium pobranych plików z pakietami. Usuwa z katalogów /var/cache/apt/archives/ i /var/cache/apt/archives/partial/ wszystko oprócz pliku blokady. Gdy APT jest używane jako metoda programu dselect(8), clean jest uruchamiane automatycznie. Osoby nie używające dselect, mogą chcieć od czasu do czasu uruchamiać apt-get clean, aby zwolnić trochę miejsca na dysku.

autoclean
    autoclean, podobnie jak clean, czyści lokalne repozytorium pobranych plików z pakietami. Różnica polega na tym, że autoclean usuwa tylko te pliki pakietów, które już nie mogą zostać pobrane i w większości są bezużyteczne. Pozwala to na uniknięcie przed długi czas niekontrolowanego wzrostu rozmiaru bufora.

OPCJE
Wszystkie opcje linii poleceń mogą być ustawione w pliku konfiguracyjnym. Poniższe opisy wskazują, którą opcję w pliku konfiguracyjnym należy ustawić. W przypadku opcji logicznych, można unieważnić ustawienia pliku konfiguracyjnego, używając -f-, --no-f, -f=no albo czegoś podobnego.

-d, --download-only
    Tylko pobieranie; pliki z pakietami są tylko pobierane, ale nie rozpakowywane czy instalowane. Odpowiadający element konfiguracji: APT::Get::Download-Only.

-f, --fix-broken
    Poprawianie; podjęcie próby poprawienia uszkodzonych zależności. Używanie tej opcji z install/remove może spowodować pominięcie któregoś z pakietów podanych w linii poleceń, co pozwoli programowi APT znaleźć właściwe rozwiązanie problemu. Któryś z podanych w linii poleceń pakietów musi stanowić jego rozwiązanie. Ta opcja jest czasami potrzebna przy pierwszym uruchomieniu APT, który nie pozwala na występowanie w systemie niespełnionych zależności. Jest również prawdopodobne, że struktura zależności w systemie jest zniszczone do tego stopnia, że będzie wymagała ręcznej interwencji (co zazwyczaj oznacza użycie dselect lub dpkg --remove w celu usunięcia niektórych winnych tego stanu pakietów). W pewnych sytuacjach użycie tej opcji łącznie z -m może spowodować błąd. Odpowiadający element konfiguracji: APT::Get::Fix-Broken.

-h, --help
    Pokazuje krótką informację o sposobie użycia.

-v, --version
    Pokazuje wersję programu.

-m, --ignore-missing, --fix-missing
    Ignoruje brakujące pakiety. Pakiety, które nie mogą być pobrane lub nie powiedzie się test spójności pakietu po jego pobraniu (plik z pakietem jest uszkodzony), zostaną wstrzymane. W pewnych sytuacjach użycie tej opcji łącznie z -f może spowodować błąd. Pakiet, który jest wybrany do instalacji (w szczególności wymieniony w linii poleceń), ale nie może zostać pobrany, zostanie po cichu pominięty. Odpowiadający element konfiguracji: APT::Get::ignore-missing.

-S, --summary
    Uzywane z poleceniami upgrade lub dist-upgrade wypisuje informacje o tym, co byłoby uaktualnione, podając poziom ważności i podsumowanie zmian (gdy te informacje są dostępne) i kończy. Odpowiadający element konfiguracji: APT::Get::Show-Upgrade-Summary.

--no-download
    Wyłącza pobierania pakietów. Najlepiej stosować z --ignore-missing, aby wymusić na APT używanie tylko tych plików .deb, które zostały wcześniej pobrane. Odpowiadający element konfiguracji: APT::Get::No-Download.

-q, --quiet
    Po cichu; wypisuje tylko informacje potrzebne do logowania, opuszczając wskaźniki postępu. Więcej znaków q spowoduje jeszcze bardziej ciche wyjście, maksimum wynosi 2. Można także ustawić poziom cichości za pomocą -q=#, nadpisując tym samym opcję z pliku konfiguracyjnego. Należy zauważyć, że poziom cichości równy 2 implikuje -y, dlatego -qq nigdy nie powinno być używane bez opcji typu -d, --print-uris lub -s, gdyż APT może zadecydować o zrobieniu czegoś, czego użytkownik się nie spodziewa. Odpowiadający element konfiguracji: quiet.

-s, --simulate, --just-print, --dry-run, --recon,, -no-act
    Brak akcji; wykonuje symulację zdarzeń, które mogłyby wystąpić, ale nic nie zmienia w systemie. Odpowiadający element konfiguracji: APT::Get::Simulate.

    Symulacja powoduje wypisanie serii linii, z których każda reprezentuje operację programu dpkg: konfigurowanie (Conf), usunięcie (Remv), rozpakowanie (Inst). Nawiasy kwadratowe oznaczają uszkodzone pakiety, przy czym pusty zbiór pakietów w nawiasach kwadratowych oznacza brak następstw (rzadkość).

-y, --yes, --assume-yes
    Automatyczna odpowiedź "tak" na pytania. Zakładając odpowiedź "tak" na wszelkie pytania, uruchamia się w trybie nieinteraktywnym. Jeśli wystąpi jakaś sytuacja niepożądana, na przykład zmiana wstrzymanego pakietu lub usunięcie istotnego pakietu, apt-get przerwie działanie. Odpowiadający element konfiguracji: APT::Get::Assume-Yes.

-u, --show-upgraded
    Pokazuje uaktualnione pakiety. Wypisuje listę wszystkich pakietów, które będą uaktualnione. Odpowiadający element konfiguracji: APT::Get::Show-Upgraded.

-b, --compile, --build
    Kompiluje pakiety źródłowe po ich pobraniu. Odpowiadający element konfiguracji: APT::Get::Compile.

--ignore-hold
    Ignoruje wstrzymanie pakietów. Ta opcja powoduje, że apt-get zignoruje status "wstrzymany" pakietów. Może to być przydatne w połączeniu z dist-upgrade do unieważnienia dużej liczby niepożądanych wstrzymań. Odpowiadający element konfiguracji: APT::Ignore-Hold.

--no-upgrade
    Nie aktualizuje pakietów. no-upgrade użyte w połączeniu z install spowoduje, że te z wymienionych w linii poleceń pakietów, które są już zainstalowane, nie zostaną zaktualizowane. Odpowiadający element konfiguracji: APT::Get::no-upgrade.

--force-yes
    Wymuszenie. Jest to niebezpieczna opcja, która powoduje, że apt-get kontynuuje swoje działanie bez żadnej interakcji z użytkownikiem, nawet jeśli robi coś, co może być szkodliwe. Nie powinna być używana z wyjątkiem bardzo szczególnych sytuacji. Używanie force-yes może zniszczyć system! Odpowiadający element konfiguracji: APT::Get::force-yes.

--print-uris
    Nie pobiera pakietów do zainstalowania, tylko wypisuje ich URI. Każdy URI składa się z lokalizacji, nazwy pliku przeznaczenia, rozmiaru oraz oczekiwanej sumy kontrolnej md5. Należy zauważyć, że nazwa pliku przeznaczenia nie musi być taka sama jak nazwa zdalnego pliku! Ta opcja działa także z poleceniem source. Odpowiadający element konfiguracji: APT::Get::Print-URIs.

--purge
    Podczas usuwania pakietu, usuwa także jego pliki konfiguracyjne. Ta opcja jest ignorowana w systemach opartch na RPM. Odpowiadający element konfiguracji: APT::Get::Purge.

--reinstall
    Ponownie instaluje pakiety, których najnowsza wersja już jest zainstalowana.

--list-cleanup
    Ta opcja jest domyślnie włączona, można ją wyłączyć używając --no-list-cleanup. Jeżeli jest włączona, apt-get będzie automatycznie zarządzał zawartością /var/lib/apt/lists, tak aby przestarzałe pliki były usuwane. Jedynym powodem dla jej wyłączenia mogłyby być częste zmiany w sources.list. Odpowiadający element konfiguracji: APT::Get::List-Cleanup.

--trivial-only
    Wykonuje tylko 'banalne' (ang. 'trivial') operacje. Tę opcję można porównać z --assume-yes, ale tam gdzie --assume-yes odpowiedziałoby "tak" na pytanie, --trivial-only odpowie "nie". Odpowiadający element konfiguracji: APT::Get::Trivial-Only.

--no-remove
    Jeżeli jakikolwiek pakiet miałby zostać usunięty, apt-get natychmiast kończy działanie, bez pytania o potwierdzenie. Odpowiadający element konfiguracji: APT::Get::No-Remove.

--diff-only, --tar-only
    Pobiera tylko plik diff albo tar pakietu źródłowego. Odpowiadający element konfiguracji: APT::Get::Diff-Only.

-c, --config-file
    Plik konfiguracyjny. Określa plik konfiguracyjny, którego należy użyć. Program najpierw przeczyta swój domyślny plik konfiguracyjny, a następnie plik podany jako argument tej opcji. Informacje na temat składni można znaleźć w apt.conf(5).

-o, --option
    Ustawia opcję konfiguracyjną. Można ustawić dowolną opcję konfiguracyjną, Składnia jest następująca:
    -o Foo::Bar=bar

PLIKI

o   /etc/apt/sources.list lokalizacje, z których będą pobierane pakiety

o   /var/cache/apt/archives/ składnica pobranych plików z pakietami

o   /var/cache/apt/archives/partial/ składnica właśnie pobieranych plików z pakietami

o   /var/lib/apt/lists/ składnica informacji o stanie każdej lokalizacji pakietów podanej w sources.list

o   /var/lib/apt/lists/partial/ składnica informacji o stanie w trakcie pobierania.

ZOBACZ TAKŻE

apt-cache(8), dpkg(8), dselect(8), sources.list(5), apt.conf(5), Przewodnik dla użytkowników programu APT w /usr/share/doc/apt*/,

DIAGNOSTYKA
apt-get zwraca zero, gdy zakończyło się pomyślnie, 100 dziesiętnie - w przypadku błędu.

BŁĘDY

Zobacz http://bugs.debian.org/apt. Aby złożyć raport o błędzie w APT, przeczytaj /usr/share/doc/debian/bug-reporting.txt lub użyj polecenia bug(1). Jeśli korzystasz z programu apt w systemie opartym na RPM, korzystaj z http://distro.conectiva.com.br/bugzilla/.

AUTOR
apt-get został napisany przez zespół APT <apt@packages.debian.org> a do potrzeb systemów opartych na RPM przystosował go Alfredo K. Kojima z Conectiva S.A. <kojima@conectiva.com.br>.